#!/usr/bin/python3

import math
from functools import cache


def is_prime(num: int) -> bool:
    if num in (1, 2):
        return True

    for i in range(2, math.ceil(num**0.5)+1):
        if (num % i) == 0:
            return False
    return True

primes = [i for i in range(2, 212) if is_prime(i)]

dist = int(input())

candidates = [i for i in primes if i <= dist]

max_dist = 14

@cache
def count_paths(idx: int) -> int:
    if idx == len(candidates)-1:
        return 1
    begin = candidates[idx]
    paths = 0
    for i in range(idx+1, len(candidates)):
        if candidates[i] - begin <= max_dist:
            paths += count_paths(i)
    return paths


print(count_paths(0))

