#!/usr/bin/python3

import math
from functools import cache


def get_divisors(num: int) -> set[int]:
    divisors = {}
    for i in range(1, math.ceil(num**0.5) + 1):
        if num % i == 0:
            divisors.add(i)
            divisors.add(num//i)
    return divisors


numbers = int(input())
practical_nums = {}


@cache
def is_num_practical(num: int) -> bool:
    global practical_nums
    if num in practical_nums:
        return True


def is_practical(num: int) -> bool:
    global practical_nums = get_divisors(num)
    is_num_practical.cache_clear()    
    return all(map(is_num_practical, range(2, num)))


for i in range(numbers):
    n = int(input())
    print(("No", "Yes")[is_practical(n)])

